<?php
/*
* group_management() is an interface for the admin to alter all user settings
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/

function gmanage()
{
	if(isset($_REQUEST['setGroupSettings'])) {
			$_SESSION['user']->setGroupSettings($_POST['groupname'],$_POST['newSettings']);
			//showUserDetails of edited user
			$_GET['showGroupDetails'] = '1';
			$_GET['groupname'] = $_POST['groupname'];
			
	} elseif(isset($_REQUEST['delGroup'])) {
			if(isset($_POST['YESDELGROUP'])){
				$_SESSION['user']->delGroup($_POST['groupname']);
			}
			elseif(isset($_POST['NODELGROUP'])){
				$_SESSION['message'] .= sprintf(_("%s \"%s\" was NOT removed!"),_("Group"), $_POST['groupname']);
				$_GET['showGroupDetails'] = '1';
				$_GET['groupname'] = $_POST['groupname'];
			}else{
				// Print confirmation page
				$content .= '<div align="center">'.NL;
				$content .= 'Are you sure remove Group "'.$_POST['groupname'].'" ?'.NL;
				$content .= '<form action="index.php" method="POST">'.NL;
				$content .= '<input type="hidden" name="CORE_OP" value="gmanage" />'.NL;
				$content .= '<input type="hidden" name="delGroup" value="1" />'.NL;
				$content .= '<input type="hidden" name="groupname" value="'.$_POST['groupname'].'" />'.NL;
				$content .= '<input type="submit" name="YESDELGROUP" value="'._("Yes").'" />'.NL;
				$content .= "&nbsp;&nbsp;&nbsp;\n";
				$content .= '<input type="submit" name="NODELGROUP" value="'._("No").'" />'.NL;
				$content .= "</form>\n</div>\n";
				return $content;
			}
		
	} elseif(isset($_REQUEST['addGroup'])) {
			$newSettings['incoming']='./';
			$newSettings['max_download_nr']='9999';
			$newSettings['max_download_vol']='99999999';
			$_SESSION['user']->addGroup($_POST['newgroup'],$newSettings);
			//when the group was successfully added change the dtailed view to the new group, or restore the old view
			$_GET['showGroupDetails']='1';
			if(in_array($_POST['newgroup'],array_keys($_SESSION['user']->groupSettings)))
			{
				$_GET['groupname'] = $_POST['newgroup'];
			} else {
				$_GET['groupname'] = $_POST['groupname'];
			}
		
	} elseif(isset($_REQUEST['addGroupMembers'])) {
		
			$_SESSION['user']->addGroupMembers($_POST['groupname'],$_POST['selUsers']);
			//select group details
			$_GET['showGroupDetails'] = '1';
			$_GET['groupname'] = $_POST['groupname'];
	
	} elseif(isset($_REQUEST['delGroupMembers'])) {
			$_SESSION['user']->delGroupMembers($_POST['groupname'],$_POST['selUsers']);
			//select group details
			$_GET['showGroupDetails'] = '1';
			$_GET['groupname'] = $_POST['groupname'];
	}

	$_SESSION['headline'] = _("Group Management");
	
	//print group selection
	$groups = array_keys($_SESSION['user']->groupSettings);
	$temp = count($groups);
	natcasesort($groups);
	foreach($groups as $name)
	{
		$i++;
		$content .= '<a href="index.php?CORE_OP=gmanage&showGroupDetails=1&groupname='.$name.'">'.$name."</a>";
		if($i<$temp){$content .= ' |  ';}
	}
	$content .= '<br><br>'.NL;
	
	//add user
	$content .= '<form action="index.php" method="POST">'.NL;
	$content .= '<input type="text" name="newgroup"  size="14" maxlength="14" />'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="gmanage" />'.NL;
	$content .= '<input type="submit" name="addGroup" value="'._("Add Group").'" />'.NL;
	$content .= "<form>\n";
	
	//show group details
	if($_GET['showGroupDetails'] == '1' AND isset($_GET['groupname'])) // use of $_REQUEST because of the <a href... some lines above
	{
		$groupname=$_GET['groupname'];
		$content .= "<br><br><hr>\n";
		$content .= '<h3>'._("Group").': "'.$groupname.'"</h3>'.NL;
		
		//Settings
		$content .= '<h4>'._("Settings").":</h4>\n";
		$content .= '<form action="index.php" method="post">'.NL;
		$content .= '<table border="0" cellpadding="5" cellspacing="0">'.NL;

		$content .= "<tr>\n";
		$content .= '<td>'._("Incoming").':</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[incoming]" value="'.$_SESSION['user']->groupSettings[$groupname]['incoming'].'" /></td>'.NL;
		$content .= '<td>'._("Directory").'</td></tr>'.NL;
		$content .= "</tr>\n";
		
		$content .= "<tr>\n";
		$content .= '<td>'._("Max. Download No.").':</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[max_download_nr]" value="'.$_SESSION['user']->groupSettings[$groupname]['max_download_nr'].'" /></td>'.NL;
		$content .= '<td>0 - 9999</td></tr>'.NL;
		$content .= "</tr>\n";
		
		$content .= "<tr>\n";
		$content .= '<td>'._("Max. Download Volume").':</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[max_download_vol]" value="'.$_SESSION['user']->groupSettings[$groupname]['max_download_vol'].'" /></td>'.NL;
		$content .= '<td>0 - 99999999 MB</td></tr>'.NL;
		$content .= "</tr>\n";

		$content .= '</table>'."<br />\n";
		$content .= '<input type="submit" name="setGroupSettings" value="'._("Save Settings")."\" />\n";
		$content .= '<input type="hidden" name="CORE_OP" value="gmanage" />'.NL;
		$content .= '<input type="hidden" name="groupname" value="'.$groupname.'" />'.NL;
		$content .= "</form>\n";
		$content .= "<br><br>\n";
		
		//view/remove group members / delete group
		$content .= '<h4>'._("Group Members").":</h4>\n";
		$content .= '<form action="index.php" method="post">'.NL;
		$content .= '<table border="0" cellpadding="10" cellspacing="0">'.NL;
		if($_SESSION['user']->groupSettings[$groupname]['members']!=NULL)
		{
			$content .= '<tr><td></td><td>'._("User").'</td><td></td><td>'._("Add");
			$content .= '</td><td>'._("Cancel").'</td><td>'._("Pause/Resume");
			$content .= '</td><td>'._("Priority").'</td><td>'._("Rename")."</td><td></td></tr>\n";
			
			foreach($_SESSION['user']->groupSettings[$groupname]['members'] as $username => $rights)
			{
				$content .= '<tr align="center">';
				$content .= '<td><input type="checkbox" name="selUsers[]" value="'.$username.'" /></td>';
				$content .= '<td><a href="index.php?CORE_OP=umanage&showUserDetails=1&username='.$username.'">'.$username."</a><td>";
		
				$content .= '<td>';
				if($rights%2 >= 1){  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
				$content .= "</td>";
				
				$content .= '<td>';
				if($rights%4 >= 2){  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
				$content .= "</td>";
				
				$content .= '<td>';
				if($rights%8 >= 4){  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
				$content .= "</td>";
				
				$content .= '<td>';
				if($rights%16 >= 8){  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
				$content .= "</td>";
				
				$content .= '<td>';
				if($rights%32 >= 16){  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
				$content .= "</td>";
				$content .= "</tr>\n";
			}
		} else {
			$content .= "<tr><td>"._("None (empty)")."</td></tr>\n";
		}
		$content .= '</table>'.NL;
		$content .= "<br><br>\n";
		$content .= '<input type="submit" name="delGroupMembers" value="'._("Remove Users")."\" />\n";
		$content .= '<input type="submit" name="delGroup" value="'._("Delete Group")."\" />\n";
		$content .= '<input type="hidden" name="CORE_OP" value="gmanage" />'.NL;
		$content .= '<input type="hidden" name="groupname" value="'.$groupname.'" />'.NL;
		$content .= "</form>\n";
		$content .= "<br><br>\n";
		
		//add group members
		$content .= '<form action="index.php" method="post">'.NL;
		$content .= '<select name="selUsers[]" size="5" multiple="multiple">'.NL;
		
		foreach(array_keys($_SESSION['user']->userSettings) as $user)
		{
			$content .='<option>'.$user."</option>\n";
		}
		$content .="</select>\n";
		$content .= '<br><input type="submit" name="addGroupMembers" value="'._("Add Group Members")."\" />\n";
		$content .= '<input type="hidden" name="CORE_OP" value="gmanage" />'.NL;
		$content .= '<input type="hidden" name="groupname" value="'.$groupname.'" />'.NL;
		$content .= "</form>\n";
	}
	
	return $content;
}
?>