<?php

/**
* Lists files being uploaded and the uploaders
*
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function upl()
{
	$_SESSION['headline'] = _("Uploads");
	
	$headers = array();
	$headers["nr"]          = _("No.");
	$headers["name"]        = _("File");
	$headers["user"]        = _("User");
	$headers["client"]      = _("Client");
	$headers["score"]       = _("Rating");
	$headers["uploaded"]    = _("Uploaded");
	$headers["downloaded"]  = _("Downloaded");
	$headers["ip"]          = _("IP Address");
	$headers["network"]     = _("Network");
	$columns = count($headers);
	
	$content .= '<table cellspacing="0" cellpadding="2" border="0">'.NL;

	$content .= '<tr class="bg_dark">'.NL;
	foreach($headers as $key => $value)
	if($key != "action")
		$content .= '<th><a class="header" href="index.php?CORE_OP=upl&SORTKEY='.$key.'&SORTORDER=ASC">&darr;</a>'.$value.'<a class="header" href="index.php?CORE_OP=upl&SORTKEY='.$key.'&SORTORDER=DESC">&uarr;</a></th>'.NL;
	else
		$content .= "<th>$value</th>\n";
	$content .= "</tr>\n";

	$_SESSION['interface']->setRate();
	$ufiles = $_SESSION['interface']->getUploaders();
	
	if(count($ufiles) > 0) {
		
	$files = sort_objects($ufiles, "score", "DESC", "upl");

	$c = 0;
	foreach($files as $filelevel) {
		foreach($filelevel as $file) {
			
			if($c%2 == 0) { $content .= '<tr class="list">'.NL; }
			else { $content .= '<tr class="alt_list">'.NL; }
			
			$content .= '<td align="left">'.$file->nr."</td>\n";
			$content .= '<td align="left">'.hrName($file->name)."</td>\n";
			$content .= '<td align="center">'.$file->user."</td>\n";
			$content .= '<td align="center">'.$file->client."</td>\n";
			$content .= '<td align="center">'.$file->score."</td>\n";
			$content .= '<td align="right">'.hrSize($file->uploaded)."</td>\n";
			$content .= '<td align="right">'.hrSize($file->downloaded)."</td>\n";
			$content .= '<td align="center">'.$file->ip."</td>\n";
			$content .= '<td align="center">'.formatNetwork($file->network, "image")."</td>\n";
			$content .= "</tr>\n";
			$c++;
		}
	}
	} else {
	$content .= '<tr class="alt_list">'.NL;
	$content .= '<td align="center" colspan="'.$columns.'"><b>'.sprintf(_("No %s."), _("Uploads")).'</b></td>';
	$content .= "</tr>\n";
	}
	
	$content .= "<tr>\n";
	$content .= '<td colspan="'.$columns.'" align="right">'.NL;
	$content .= "<strong>"._("Total Upload Rate") . ": ".sprintf("%01.1f", $_SESSION['interface']->upload_rate)." KB/s</strong>\n";
	$content .= "</td>\n";
	$content .= "</tr>\n";
	
	$content .= "</table>\n";
	
	return $content;
}
?>
